// ======================================================================
// \title  FppTypePortAc.cpp
// \author Generated by fpp-to-cpp
// \brief  cpp file for FppType port
// ======================================================================

#include "FppTypePortAc.hpp"
#include "Fw/Types/Assert.hpp"
#include "Fw/Types/StringUtils.hpp"

namespace {

  // ----------------------------------------------------------------------
  // Port buffer class
  // ----------------------------------------------------------------------

  class FppTypePortBuffer : public Fw::SerializeBufferBase {

    public:

      NATIVE_UINT_TYPE getBuffCapacity() const {
        return InputFppTypePort::SERIALIZED_SIZE;
      }

      U8* getBuffAddr() {
        return m_buff;
      }

      const U8* getBuffAddr() const {
        return m_buff;
      }

    private:

      U8 m_buff[InputFppTypePort::SERIALIZED_SIZE];

  };

}

// ----------------------------------------------------------------------
// Input Port Member functions
// ----------------------------------------------------------------------

InputFppTypePort ::
  InputFppTypePort() :
    Fw::InputPortBase(),
    m_func(nullptr)
{

}

void InputFppTypePort ::
  init()
{
  Fw::InputPortBase::init();
}

void InputFppTypePort ::
  addCallComp(
      Fw::PassiveComponentBase* callComp,
      CompFuncPtr funcPtr
  )
{
  FW_ASSERT(callComp);
  FW_ASSERT(funcPtr);

  this->m_comp = callComp;
  this->m_func = funcPtr;
  this->m_connObj = callComp;
}

void InputFppTypePort ::
  invoke(
      const E& e,
      E& eRef,
      const A& a,
      A& aRef,
      const S& s,
      S& sRef
  )
{
#if FW_PORT_TRACING == 1
  this->trace();
#endif

  FW_ASSERT(this->m_comp);
  FW_ASSERT(this->m_func);

  return this->m_func(this->m_comp, this->m_portNum, e, eRef, a, aRef, s, sRef);
}

#if FW_PORT_SERIALIZATION == 1

Fw::SerializeStatus InputFppTypePort ::
  invokeSerial(Fw::SerializeBufferBase& _buffer)
{
  Fw::SerializeStatus _status;

#if FW_PORT_SERIALIZATION == 1
  this->trace();
#endif

  FW_ASSERT(this->m_comp);
  FW_ASSERT(this->m_func);

  E e;
  _status = _buffer.deserialize(e);
  if (_status != Fw::FW_SERIALIZE_OK) {
    return _status;
  }

  E eRef;
  _status = _buffer.deserialize(eRef);
  if (_status != Fw::FW_SERIALIZE_OK) {
    return _status;
  }

  A a;
  _status = _buffer.deserialize(a);
  if (_status != Fw::FW_SERIALIZE_OK) {
    return _status;
  }

  A aRef;
  _status = _buffer.deserialize(aRef);
  if (_status != Fw::FW_SERIALIZE_OK) {
    return _status;
  }

  S s;
  _status = _buffer.deserialize(s);
  if (_status != Fw::FW_SERIALIZE_OK) {
    return _status;
  }

  S sRef;
  _status = _buffer.deserialize(sRef);
  if (_status != Fw::FW_SERIALIZE_OK) {
    return _status;
  }

  this->m_func(this->m_comp, this->m_portNum, e, eRef, a, aRef, s, sRef);

  return Fw::FW_SERIALIZE_OK;
}

#endif

// ----------------------------------------------------------------------
// Output Port Member functions
// ----------------------------------------------------------------------

OutputFppTypePort ::
  OutputFppTypePort() :
    Fw::OutputPortBase(),
    m_port(nullptr)
{

}

void OutputFppTypePort ::
  init()
{
  Fw::OutputPortBase::init();
}

void OutputFppTypePort ::
  addCallPort(InputFppTypePort* callPort)
{
  FW_ASSERT(callPort);

  this->m_port = callPort;
  this->m_connObj = callPort;

#if FW_PORT_SERIALIZATION == 1
  this->m_serPort = nullptr;
#endif
}

void OutputFppTypePort ::
  invoke(
      const E& e,
      E& eRef,
      const A& a,
      A& aRef,
      const S& s,
      S& sRef
  )
{
#if FW_PORT_TRACING == 1
  this->trace();
#endif

#if FW_PORT_SERIALIZATION
  FW_ASSERT(this->m_port || this->m_serPort);
#else
  FW_ASSERT(this->m_port);
#endif
  if (this->m_port) {
    this->m_port->invoke(e, eRef, a, aRef, s, sRef);
#if FW_PORT_SERIALIZATION
  } else if (this->m_serPort) {
    Fw::SerializeStatus _status;
    FppTypePortBuffer _buffer;

    _status = _buffer.serialize(e);
    FW_ASSERT(_status == Fw::FW_SERIALIZE_OK, static_cast<FwAssertArgType>(_status));

    _status = _buffer.serialize(eRef);
    FW_ASSERT(_status == Fw::FW_SERIALIZE_OK, static_cast<FwAssertArgType>(_status));

    _status = _buffer.serialize(a);
    FW_ASSERT(_status == Fw::FW_SERIALIZE_OK, static_cast<FwAssertArgType>(_status));

    _status = _buffer.serialize(aRef);
    FW_ASSERT(_status == Fw::FW_SERIALIZE_OK, static_cast<FwAssertArgType>(_status));

    _status = _buffer.serialize(s);
    FW_ASSERT(_status == Fw::FW_SERIALIZE_OK, static_cast<FwAssertArgType>(_status));

    _status = _buffer.serialize(sRef);
    FW_ASSERT(_status == Fw::FW_SERIALIZE_OK, static_cast<FwAssertArgType>(_status));

    _status = this->m_serPort->invokeSerial(_buffer);
    FW_ASSERT(_status == Fw::FW_SERIALIZE_OK, static_cast<FwAssertArgType>(_status));
  }
#else
  }
#endif
}
